#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "M_ActivityIntegralExchangeCFG.h"
std::auto_ptr<M_ActivityIntegralExchangeCFG> M_ActivityIntegralExchangeCFG::msSingleton(nullptr);

int M_ActivityIntegralExchangeCFG::GetCount()
{
	return (int)mMapData.size();
}

const M_ActivityIntegralExchangeCFGData* M_ActivityIntegralExchangeCFG::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, M_ActivityIntegralExchangeCFGData>& M_ActivityIntegralExchangeCFG::GetMapData()
{
	return mMapData;
}

void M_ActivityIntegralExchangeCFG::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/M_ActivityIntegralExchangeCFG.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_ActivityIntegralExchangeCFGData data;
		data.mID = element->IntAttribute("ID");
		data.mVoucherId = element->IntAttribute("VoucherId");
		data.mVoucherCount = element->IntAttribute("VoucherCount");
		data.mItemId = element->IntAttribute("ItemId");
		data.mItemCount = element->IntAttribute("ItemCount");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
	CCLOG("M_ActivityIntegralExchangeCFG Loaded. Load Data:%u", mMapData.size());
}

void M_ActivityIntegralExchangeCFG::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/M_ActivityIntegralExchangeCFG");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "M_ActivityIntegralExchangeCFG");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		M_ActivityIntegralExchangeCFGData data;
		LuaCfgHelper::readInt(L, "ID", data.mID);
		LuaCfgHelper::readInt(L, "VoucherId", data.mVoucherId);
		LuaCfgHelper::readInt(L, "VoucherCount", data.mVoucherCount);
		LuaCfgHelper::readInt(L, "ItemId", data.mItemId);
		LuaCfgHelper::readInt(L, "ItemCount", data.mItemCount);
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("M_ActivityIntegralExchangeCFG Loaded. Load Data:%u", mMapData.size());
}

void M_ActivityIntegralExchangeCFG::Reload()
{
	mMapData.clear();
	Load();
}

M_ActivityIntegralExchangeCFG* M_ActivityIntegralExchangeCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_ActivityIntegralExchangeCFG());
	}
	return msSingleton.get();
}

void M_ActivityIntegralExchangeCFG::Release()
{
	msSingleton.reset(nullptr);
}
